Attribute VB_Name = "Module2"
Option Explicit

Private Const C As Single = 0.5

Public pl   As Single
Public ph   As Single
Public R    As Single

Dim ql      As Single

Dim vcl As Single
Dim il  As Single
Dim ull As Single
Dim ulh As Single
Dim dt  As Single


Public lsx          As Long
Public lsx2         As Long


Public Const Buflen = 2048          'Numero di campioni da visualizzare

Public samplerate       As Long     'Frequenza di campionamento
Public Bits_Per_Sample  As Integer
Public Channels         As Integer

Public sx

Public vol  As Long

Public bb()         As Integer


Public Type MMTIME
    wType   As Long
    u       As Long
End Type

Public Declare Function waveOutBreakLoop Lib "winmm.dll" (ByVal hWaveOut As Long) As Long
Public Declare Function waveOutClose Lib "winmm.dll" (ByVal hWaveOut As Long) As Long
Public Declare Function waveOutGetDevCaps Lib "winmm.dll" Alias "waveOutGetDevCapsA" (ByVal uDeviceID As Long, lpCaps As WAVEOUTCAPS, ByVal uSize As Long) As Long
Public Declare Function waveOutGetID Lib "winmm.dll" (ByVal hWaveOut As Long, lpuDeviceID As Long) As Long
Public Declare Function waveOutGetErrorText Lib "winmm.dll" Alias "waveOutGetErrorTextA" (ByVal err As Long, ByVal lpText As String, ByVal uSize As Long) As Long
Public Declare Function waveOutGetNumDevs Lib "winmm.dll" () As Long
Public Declare Function waveOutGetPitch Lib "winmm.dll" (ByVal hWaveOut As Long, lpdwPitch As Long) As Long
Public Declare Function waveOutGetPlaybackRate Lib "winmm.dll" (ByVal hWaveOut As Long, lpdwRate As Long) As Long
Public Declare Function waveOutGetPosition Lib "winmm.dll" (ByVal hWaveOut As Long, lpInfo As MMTIME, ByVal uSize As Long) As Long
Public Declare Function waveOutGetVolume Lib "winmm.dll" (ByVal uDeviceID As Long, lpdwVolume As Long) As Long
Public Declare Function waveOutMessage Lib "winmm.dll" (ByVal hWaveOut As Long, ByVal Msg As Long, ByVal dw1 As Long, ByVal dw2 As Long) As Long
Public Declare Function waveOutOpen Lib "winmm.dll" (lphWaveOut As Long, ByVal uDeviceID As Long, lpFormat As WAVEFORMATEX, ByVal dwCallback As Long, ByVal dwInstance As Long, ByVal dwFlags As Long) As Long
Public Declare Function waveOutPause Lib "winmm.dll" (ByVal hWaveOut As Long) As Long
Public Declare Function waveOutPrepareHeader Lib "winmm.dll" (ByVal hWaveOut As Long, lpWaveOutHdr As WAVEHDR, ByVal uSize As Long) As Long
Public Declare Function waveOutReset Lib "winmm.dll" (ByVal hWaveOut As Long) As Long
Public Declare Function waveOutRestart Lib "winmm.dll" (ByVal hWaveOut As Long) As Long
Public Declare Function waveOutSetPitch Lib "winmm.dll" (ByVal hWaveOut As Long, ByVal dwPitch As Long) As Long
Public Declare Function waveOutSetPlaybackRate Lib "winmm.dll" (ByVal hWaveOut As Long, ByVal dwRate As Long) As Long
Public Declare Function waveOutSetVolume Lib "winmm.dll" (ByVal uDeviceID As Long, ByVal dwVolume As Long) As Long
Public Declare Function waveOutUnprepareHeader Lib "winmm.dll" (ByVal hWaveOut As Long, lpWaveOutHdr As WAVEHDR, ByVal uSize As Long) As Long
Public Declare Function waveOutWrite Lib "winmm.dll" (ByVal hWaveOut As Long, lpWaveOutHdr As WAVEHDR, ByVal uSize As Long) As Long

'Per il subclassing:
Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByRef lParam As WAVEHDR) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Const GWL_WNDPROC = (-4)
Global lpPrevFunc As Long

Public Const MAXPNAMELEN = 32       'Lunghezza max nome prodotto (incluso NULL)

Public Type WAVEHDR
    lpData          As Long         'Metodo proposto da Microsoft
    dwBufferLength  As Long
    dwBytesRecorded As Long
    dwUser          As Long
    dwFlags         As Long
    dwLoops         As Long
    lpNext          As Long
    Reserved        As Long
End Type

Public Type WAVEFORMATEX
    wFormatTag      As Integer
    nChannels       As Integer
    nSamplesPerSec  As Long
    nAvgBytesPerSec As Long
    nBlockAlign     As Integer
    wBitsPerSample  As Integer
    cbSize          As Integer
End Type

Public Type WAVEOUTCAPS
    wMid            As Integer
    wPid            As Integer
    vDriverVersion  As Long
    szPname         As String * MAXPNAMELEN
    dwFormats       As Long
    wChannels       As Integer
    dwSupport       As Long
End Type

Public Const WAVE_FORMAT_1M08 = &H1             '11.025 kHz, Mono,   a 8 bit
Public Const WAVE_FORMAT_1M16 = &H4             '11.025 kHz, Mono,   a 16 bit
Public Const WAVE_FORMAT_1S08 = &H2             '11.025 kHz, Stereo, a 8 bit
Public Const WAVE_FORMAT_1S16 = &H8             '11.025 kHz, Stereo, a 16 bit
Public Const WAVE_FORMAT_2M16 = &H40            '22.05  kHz, Mono,   a 16 bit
Public Const WAVE_FORMAT_2M08 = &H10            '22.05  kHz, Mono,   a 8 bit
Public Const WAVE_FORMAT_2S08 = &H20            '22.05  kHz, Stereo, a 8 bit
Public Const WAVE_FORMAT_2S16 = &H80            '22.05  kHz, Stereo, a 16 bit
Public Const WAVE_FORMAT_4M08 = &H100           '44.1   kHz, Mono,   a 8 bit
Public Const WAVE_FORMAT_4M16 = &H400           '44.1   kHz, Mono,   a 16 bit
Public Const WAVE_FORMAT_4S08 = &H200           '44.1   kHz, Stereo, a 8 bit
Public Const WAVE_FORMAT_4S16 = &H800           '44.1   kHz, Stereo, a 16 bit
Public Const WAVE_MAPPER = -1&
Public Const CALLBACK_WINDOW = &H10000          'dwCallback  un HWND
Public Const CALLBACK_FUNCTION = &H30000        'dwCallback  un FARPROC

Public Const MM_WOM_OPEN = &H3BB                'Output waveform
Public Const MM_WOM_DONE = &H3BD
Public Const MM_WOM_CLOSE = &H3BC
Public Const WHDR_PREPARED = &H2                'Imposta se questa intestazione  pronta

Public Const Buffers = 4                        'Utilizzeremo due buffer (double-buffering)
    'se ne utilizziamo tre aumenta la stabilit, ma diminuisce la velocit
    'di risposta del sistema ad eventuali cambiamenti del segnale.
    

Global Buffer_Data(Buflen, 0 To Buffers - 1) As Integer 'Dichiaro i buffers globali con i settaggi delle costanti precedenti
Global Headers(0 To Buffers - 1) As WAVEHDR 'Anche gli header vanno dichiarati come globali, in quantit uguale ai buffer

Global current_header  As Long

Global wave_handle As Long 'Questa variabile conterr l'handle ritornato da waveOutOpen che ci serve anche per chiudere terminare l'operazione con waveOutClose

Global Resetting As Long 'Flag per la sincronizzazione con la funzione callback, nella Window Procedure invece utilizziamo una propriet del form


Public Sub FillBuffer(Index As Long)
On Error GoTo errore
Dim lx  As Long
Dim x   As Long
Dim p   As Long
Dim sx  As Long
Dim sx2 As Long
    dt = 1 / samplerate
    Form1.Osc.Cls
    For x = 0 To Buflen - 1
        vcl = ql / C
        il = (bb(x) - vcl) / R
        ql = ql + il * dt
        ull = vcl
        ulh = bb(x) - vcl
        'MIX
        Buffer_Data(x, Index) = ull * pl + ulh * ph
        'Disegna
'        If x Mod 8 = 0 Then
            sx = 32767& - bb(x)
            sx2 = 32767& - Buffer_Data(x, Index)
            Form1.Osc.Line (x, sx)-(lx, lsx), vbGreen
            Form1.Osc.Line (x, sx2)-(lx, lsx2), vbRed
            lsx = sx
            lsx2 = sx2
            lx = x
'        End If
    Next x
Exit Sub
errore:
    'Reset
    ql = 0
End Sub


Sub Begin_waveOut()
Dim result As Long
Dim i As Long
    'Questa funzione d l'avvio, infatti poi la callback si autoalimenta da sola
    For i = 0 To Buffers - 1
        result = waveOutWrite(wave_handle, Headers(i), Len(Headers(i)))
        If result <> 0 Then
            MsgBox "Errore durante l'esecuzione dei primi header: header " & i, vbCritical, "Errore"
        End If
    Next i
End Sub

Sub Perform_waveOutReset()
Dim result  As Long
    Resetting = 1
    'Ferma i buffer che stanno suonando
    result = waveOutReset(wave_handle)
    'MsgBox "Reset send"
    If result <> 0 Then
        MsgBox "Errore durante waveOutReset", vbCritical, "Errore"
    End If
End Sub

Sub Prepare_Headers()
Dim i       As Long
Dim result  As Long
    For i = 0 To Buffers - 1
        Headers(i).lpData = VarPtr(Buffer_Data(0, i))
        Headers(i).dwBufferLength = Buflen * 2 'moltiplichiamo per 2 perch dobbiamo dare il valore in byte, ed essendo il suono a 16 bit  necessario moltiplicare appunto 2 byte per campione
        Headers(i).dwUser = i
        Headers(i).dwLoops = 0
        result = waveOutPrepareHeader(wave_handle, Headers(i), Len(Headers(i)))
        If result <> 0 Then
            MsgBox "Errore durante la preparazione dell'header " & i, vbCritical, "Errore"
        End If
    Next i
End Sub

Sub UnPrepare_Headers()
Dim i       As Long
Dim result  As Long
    For i = 0 To Buffers - 1
        result = waveOutUnprepareHeader(wave_handle, Headers(i), Len(Headers(i)))
        If result <> 0 Then
            MsgBox "Errore durante l'eliminazione dell'header " & i, vbCritical, "Errore"
        End If
    Next i
End Sub

Sub Perform_waveOutOpen()
Dim wav_format  As WAVEFORMATEX     'Struttura temporanea per aprire la sessione
Dim handle      As Long
Dim result      As Long
    Resetting = 0
    'Preparo la struttura da passare a waveOutOpen
    With wav_format
        .wFormatTag = WAVE_FORMAT_PCM
        .nBlockAlign = Channels * (Bits_Per_Sample \ 8)
        .nAvgBytesPerSec = wav_format.nBlockAlign * samplerate
        .nChannels = Channels
        .nSamplesPerSec = samplerate
        .wBitsPerSample = Bits_Per_Sample
        .cbSize = 0
    End With
    result = waveOutOpen(handle, WAVE_MAPPER, wav_format, Form1.hWnd, True, CALLBACK_WINDOW)
    If result <> 0 Then
        MsgBox "Errore durante waveOutOpen:" & result, vbCritical, "Errore"
    End If
    wave_handle = handle
End Sub


Function waveOut_Func_Subclassed(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByRef curr_header As WAVEHDR) As Long
Dim i       As Long
Dim result  As Long
    'Gestiamo i messaggi mandati dal sistema
    Select Case uMsg
        Case MM_WOM_OPEN
            Form1.SB1.Panels(1).Text = "Aperto"
        Case MM_WOM_DONE
            'Utilizziamo la propriet Tag del form per vedere se  stato chiamato waveOutReset
            If Form1.Tag = "1" Then
                waveOut_Func_Subclassed = CallWindowProc(lpPrevFunc, hWnd, uMsg, wParam, curr_header)
                Exit Function
            End If
            'Otteniamo l'header corrente (cio il buffer che  stato appena completato)
            current_header = curr_header.dwUser
            Form1.SB1.Panels(1).Text = "Buffer completo:" & current_header
            'Riempiamo il prossimo header con dei dati
            FillBuffer current_header
            'Rimettiamo nella catena questo buffer
            result = waveOutWrite(wave_handle, Headers(current_header), Len(Headers(current_header)))
            If result <> 0 Then
                MsgBox "Errore durante l'esecuzione del buffer:" & current_header, vbCritical, "Errore"
            End If
        Case MM_WOM_CLOSE
            Form1.SB1.Panels(1).Text = "Chiuso"
    End Select
    waveOut_Func_Subclassed = CallWindowProc(lpPrevFunc, hWnd, uMsg, wParam, curr_header)
End Function

Sub Perform_WaveOutClose()
Dim result  As Long
    result = waveOutClose(wave_handle)
    If result <> 0 Then
        MsgBox "Errore durante waveOutClose", vbCritical, "Errore"
    End If
    wave_handle = 0
End Sub
